import 'package:yuro/util/datetime.dart';

extension DateTimeExt on DateTime {
  /// 按照格式格式化日期
  String format([String format = DateUtil.FORMAT_DEFAULT]) => DateUtil.formatDateTime(this, format);

  /// 获取日期与当前的间隔
  int intervalByNow() => DateUtil.interval(this, DateUtil.currentDateTime);

  /// 获取指定日期当月的天数
  int get days => DateUtil.dayInMonth(this);
}
