import 'dart:convert';
import 'package:flutter/services.dart' show ByteData, rootBundle;

/// Assets工具类
class AssetsUtil {
  AssetsUtil._();

  ///加载资源目录下的json
  ///
  /// @fileName 默认带有文件后缀.json
  ///
  /// @path 默认目录assets/json
  static Future<dynamic> loadJson(String fileName, {String path = 'assets/json'}) async =>
      json.decode(await rootBundle.loadString('$path/$fileName.json'));

  ///获取资源目录下的png
  ///
  /// @pngName 文件名称
  ///
  /// @path 默认目录assets/images
  static String loadPng(String pngName, {String path = 'assets/images'}) => '$path/$pngName.png';

  /// 加载自定义目录下的文件
  ///
  /// @fileName 文件名称
  ///
  /// @path 文件路径
  static Future<ByteData> loadData(String fileName, String path) async => await rootBundle.load('$path/$fileName');
}
