import 'dart:async';

import 'package:flutter/foundation.dart';

class EventBus {
  static EventBus _instance;

  factory EventBus() => _instance ??= EventBus._();

  // ignore: close_sinks
  StreamController _streamController;

  StreamController get streamController => _streamController;

  EventBus._() {
    _streamController = StreamController.broadcast();
  }

  void customController(StreamController controller) {
    this._streamController = controller;
  }

  Stream<T> on<T>() {
    if (T == dynamic) {
      return streamController.stream;
    } else {
      return streamController.stream.where((event) => event is T).cast<T>();
    }
  }

  void send(event) => streamController.add(event);
}

class MsgEvent {
  int code;
  String msg;
  Map<String, dynamic> extra;

  MsgEvent({@required this.code, this.msg, this.extra});
}
