import 'package:shared_preferences/shared_preferences.dart';

/// SharedPreferences工具类
class SpUtil {
  SpUtil._();

  static Future<SharedPreferences> _getPreferences() async => await SharedPreferences.getInstance();

  ///获取Int
  static Future<int> getInt(String key, {int def = 0}) => _getPreferences().then((sp) => sp.getInt(key) ?? def);

  ///保存Int
  static void putInt(String key, int value) => _getPreferences().then((sp) => sp.setInt(key, value));

  ///获取Double
  static Future<double> getDouble(String key, {double def = 0.0}) => _getPreferences().then((sp) => sp.getDouble(key) ?? def);

  ///保存Double
  static void putDouble(String key, double value) => _getPreferences().then((sp) => sp.setDouble(key, value));

  /// 获取bool
  static Future<bool> getBool(String key, {bool def = false}) => _getPreferences().then((sp) => sp.getBool(key) ?? def);

  /// 保存bool
  static void putBool(String key, bool value) => _getPreferences().then((sp) => sp.setBool(key, value));

  ///获取String
  static Future<String> getString(String key, {String def = ''}) => _getPreferences().then((sp) => sp.getString(key) ?? def);

  ///保存String
  static void putString(String key, String value) => _getPreferences().then((sp) => sp.setString(key, value));

  ///获取List<String>
  static Future<List<String>> getListString(String key, {List<String> def = const []}) =>
      _getPreferences().then((sp) => sp.getStringList(key) ?? def);

  ///保存List<String>
  static void putListString(String key, List<String> value) => _getPreferences().then((sp) => sp.setStringList(key, value));

  /// 获取所有的key
  static Future<Set<String>> getKeys() => _getPreferences().then((sp) => sp.getKeys());

  /// 清空
  static Future<bool> clear() => _getPreferences().then((sp) => sp.clear());

  ///移除key
  static Future<bool> remove(String key) => _getPreferences().then((sp) => sp.remove(key));

  ///判断是否包含key
  static Future<bool> contains(String key) => _getPreferences().then((sp) => sp.containsKey(key));
}
